#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <check.h>

#include "InterfaceHeader.h"

/*
 * 
 */


int compare_two_binary_files(FILE *fp1, FILE *fp2) {
    char ch1, ch2;
    int flag = 0;
    while (((ch1 = fgetc(fp1)) != EOF) &&((ch2 = fgetc(fp2)) != EOF)) {
        if (ch1 == ch2) {
            flag = 1;
            continue;
        } else {
            fseek(fp1, -1, SEEK_CUR);
            flag = 0;
            break;
        }
    }
    if (ch1 == EOF) {
        ch2 = fgetc(fp2);
    }

    if ((ch1 != EOF) || (ch2 != EOF)) {
        flag = 0;
    }

    if (flag == 0) {
        return 1;
        //printf("Two files are not equal :  byte poistion at which two files differ is %d\n", ftell(fp1) + 1);

    } else {
        return 0;
        //printf("Two files are Equal\n ", ftell(fp1) + 1);
    }

}



START_TEST(test_1) {
    char * testInputFile = "TESTENCRYPT.c";
    char * testOracleFile = "EncryptORACLE.out";
    char * resultsFile = "encryptTransplantResults.out";
    FILE * inputFile = fopen(testInputFile, "w");
    fprintf(inputFile, "TEST TO BE ENCRYPTED \n");
    fprintf(inputFile, "random f ifsaj faioijs [ja jai [ij a[ija[[a \n");
    fprintf(inputFile, "oasdkopdsko okk oapk kokpao [plqp l qpll plqlpq  qq q q\t \t fdsfdsfds\n");
    fprintf(inputFile, "adoksaopkdkpoasopd oa kpkpodsako oasp da dsada \n");
    fclose(inputFile);
    char * commandRemoveOldFile = "rm -f encryptTransplantResults.out";
    system(commandRemoveOldFile);
    GRAFT_INTERFACE("1234", testInputFile, resultsFile);
    FILE * resultedFile = fopen(resultsFile, "r");
    FILE * oracleFile = fopen(testOracleFile, "r");
    if (compare_two_binary_files(resultedFile, oracleFile)) {
        ck_abort();
    }
    fclose(resultedFile);
    fclose(oracleFile);
}

END_TEST





START_TEST(test_2) {
    char * commandRemove = "rm -f TESTENCRYPTNONEXISTENT.c";
    system(commandRemove);
    char * testInputFile = "TESTENCRYPTNONEXISTENT.c";
    char * testOracleFile = "EncryptORACLE.out";
    char * resultsFile = "encryptTransplantResults.out";
    GRAFT_INTERFACE("1234", testInputFile, resultsFile);

}

END_TEST


START_TEST(test_3) {
    char * testInputFile = "TESTENCRYPT.c";
    char * testOracleFile = "EncryptORACLE.out";
    char * resultsFile = "TESTENCRYPT.c";
    FILE * inputFile = fopen(testInputFile, "w");
    fprintf(inputFile, "TEST TO BE ENCRYPTED \n");
    fprintf(inputFile, "random f ifsaj faioijs [ja jai [ij a[ija[[a \n");
    fprintf(inputFile, "oasdkopdsko okk oapk kokpao [plqp l qpll plqlpq  qq q q\t \t fdsfdsfds\n");
    fprintf(inputFile, "adoksaopkdkpoasopd oa kpkpodsako oasp da dsada \n");
    fclose(inputFile);
    GRAFT_INTERFACE("1234", testInputFile, resultsFile);
}

END_TEST






Suite *
money_suite(void) {

    Suite *s = suite_create("GenTransSuite");
    // Core test case 
    TCase *tc_core = tcase_create("Core");
    tcase_set_timeout(tc_core, 3);
    tcase_add_test(tc_core, test_1);
    tcase_add_test(tc_core, test_2);
    tcase_add_test(tc_core, test_3);
    suite_add_tcase(s, tc_core);
    return s;

}

int main(int argc, char** argv) {


    int number_failed;
    Suite *s = money_suite();
    SRunner *sr = srunner_create(s);
    srunner_run_all(sr, CK_SILENT);


    printf("\n\n");

    srunner_print(sr, CK_NORMAL);



    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
    //  return (EXIT_SUCCESS);
}



